<?php
/***************************************************************************
 *                          admin_rebuild_search.php
 *                            -------------------
 *   begin                : July 9th 2003
 *   copyright            : (C) 2003 Antony Bailey
 *   email                : antony_bailey@lycos.co.uk
 *
 ***************************************************************************/
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define ('IN_PHPBB', 1);

if(!empty ($setmodules))
{
	$filename = basename(__FILE__);
	$module['SQL']['Rebuild_search'] = $filename;
	return;
}

$start_time = time ();
$time_limit = $HTTP_GET_VARS['time_limit'];

$no_page_header = true;
$phpbb_root_path = './../';
require ($phpbb_root_path . 'extension.inc');
require ('pagestart.' . $phpEx);
require ($phpbb_root_path . 'includes/functions_search.'.$phpEx); 

$page_title = $lang['Page_title'];

if ( strstr($board_config['main_admin_id'], ',') )
{
	$fids = explode(',', $board_config['main_admin_id']);
	while( list($foo, $id) = each($fids) )
	{
		$fid[] = intval( trim($id) );
	}
}
else
{
	$fid[] = intval( trim($board_config['main_admin_id']) );
}
reset($fid);
if ( in_array($userdata['user_id'], $fid) == false )
{
	$message = sprintf($lang['SQL_Admin_No_Access'], '<a href="' . append_sid("admin_no_access.$phpEx") . '">', '</a>');
	message_die(GENERAL_MESSAGE, $message);
}

$mode = $HTTP_GET_VARS['mode'];

if ( $mode == 'clear' )
{
	$sql = "UPDATE " . CONFIG_TABLE . "
		SET config_value = ''
		WHERE config_name = 'rebuild_search'";
	$result = $db->sql_query ($sql);
}

$sql = "SELECT * FROM " . CONFIG_TABLE . "
	WHERE config_name = 'rebuild_search'"; 
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, 'Could not query config table for data previous rebuilding! If you dont want resume previous session just clear config table where config name = rebuild_search', '', __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$value = $row['config_value'];
	}

}

if ( $value != '' && !$total_num_rows )
{
	include('./page_header_admin.'.$phpEx);

	$rebuild_explain = $lang['Rebuild_search_explain'] . '<br /><br /><br /><br />' . sprintf($lang['resume_rebuild'], '<a href="' . append_sid($value) . '">', '</a>', '<a href="' . append_sid ("admin_rebuild_search.$phpEx?mode=clear") . '">', '</a>');
	$template->assign_vars (array (
		'L_REBUILD_SEARCH' => $lang['Rebuild_search'],
		'L_REBUILD_SEARCH_EXPLAIN' => $rebuild_explain,
		'L_POST_LIMIT' => $lang['Post_limit'],
		'L_TIME_LIMIT' => $lang['Time_limit'],
		'L_REFRESH_RATE' => $lang['Refresh_rate'],
		'SESSION_ID' => $userdata['session_id'],
		
		'S_REBUILD_SEARCH_ACTION' => append_sid("admin_rebuild_search.$phpEx"))
	);
		
	$template->set_filenames (array (
	    'body' => 'admin/rebuild_search_body.tpl')
	);
}
else
{
	if (isset ($HTTP_GET_VARS['start']))
	{
		function onTime ()
		{
			global $start_time, $time_limit;
			static $max_execution_time;
			$current_time = time ();
		
			if (empty ($max_execution_time))
			{
				if (ini_get ('safe_mode') == false)
				{
					set_time_limit (0);
					$max_execution_time = $time_limit;
				}
				else
				{
					$max_execution_time = ini_get ('max_execution_time');
				}
			}
			return (($current_time - $start_time) < $max_execution_time) ? true : false;
		}

		$start = $HTTP_GET_VARS['start'];
	
		// Let's start over again and grow ourselves new MySQL tables.
		if ($start == 0)
		{
			// Search tables
			$sql = "DELETE FROM ". SEARCH_TABLE;
			$result = $db->sql_query ($sql);

			// Word table		
			$sql = "DELETE FROM ". SEARCH_WORD_TABLE;
			$result = $db->sql_query ($sql);

			// Matches		
			$sql = "DELETE FROM ". SEARCH_MATCH_TABLE;
			$result = $db->sql_query ($sql);

			// Text		
			$sql = "SELECT post_id FROM ". POSTS_TEXT_TABLE;
			$result = $db->sql_query ($sql);
			$total_num_rows = $db->sql_numrows ($result);
		}
		// Let's make the new tables.
		$total_num_rows = (isset($HTTP_GET_VARS['total_num_rows'])) ? $HTTP_GET_VARS['total_num_rows'] : $total_num_rows;
		
		$sql = "SELECT post_id, post_subject, post_text FROM " . POSTS_TEXT_TABLE . "
			LIMIT $start, " . $HTTP_GET_VARS['post_limit'];
		$result = $db->sql_query ($sql);
		
		$num_rows = 0;
		while (($row = $db->sql_fetchrow ($result)) && (onTime () == true))
		{
			add_search_words('single', $row['post_id'], stripslashes($row['post_text']), stripslashes($row['post_subject']));
			$num_rows++;
		}
	
		// Show the template work.
		$template->set_filenames(array(
			'body' => 'admin/admin_message_body.tpl')
		);
		
		if (($start + $num_rows) != $total_num_rows)
		{
			$form_action = 'admin_rebuild_search.' . $phpEx . '?start=' . ($start + $num_rows) . '&total_num_rows=' . $total_num_rows . '&post_limit=' . $HTTP_GET_VARS['post_limit'] . '&time_limit=' . $time_limit . '&refresh_rate=' . $HTTP_GET_VARS['refresh_rate'];

			$sql = "UPDATE " . CONFIG_TABLE . "
				SET config_value = '" . $form_action . "'
				WHERE config_name = 'rebuild_search'";
			$result = $db->sql_query ($sql);

			$next = $lang['Next'];
			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="'. $HTTP_GET_VARS['refresh_rate'] .';url='. append_sid($form_action) .'">')
			);
		}
		else
		{
			$sql = "UPDATE " . CONFIG_TABLE . "
				SET config_value = ''
				WHERE config_name = 'rebuild_search'";
			$result = $db->sql_query ($sql);

			$next = $lang['Finished'];
			$form_action = append_sid ("admin_rebuild_search.$phpEx");
		}
	
		include ('./page_header_admin.'.$phpEx);
	
		$template->assign_vars (array (
			'PERCENT' => round ((($start + $num_rows) / $total_num_rows) * 100),
			'L_REBUILD_SEARCH' => $lang['Rebuild_search'],
			'L_REBUILD_SEARCH_EXPLAIN' => $lang['Rebuild_search_explain'],
			'L_NEXT' => $next,
			'L_PERCENTAGE_COMPLETE' => $lang['Percentage_complete'],
			'S_REBUILD_SEARCH_ACTION' => append_sid($form_action))
		);
	
		$template->set_filenames (array (
		    'body' => 'admin/rebuild_search_progress_body.tpl')
		);
	}
	else
	{
		include('./page_header_admin.'.$phpEx);

		// The variables, hey kids you wana edit these to add new stuff. :)
		$template->assign_vars (array (
			'L_REBUILD_SEARCH' => $lang['Rebuild_search'],
			'L_REBUILD_SEARCH_EXPLAIN' => $lang['Rebuild_search_explain'],
			'L_POST_LIMIT' => $lang['Post_limit'],
			'L_TIME_LIMIT' => $lang['Time_limit'],
			'L_REFRESH_RATE' => $lang['Refresh_rate'],
			'SESSION_ID' => $userdata['session_id'],
		
			'S_REBUILD_SEARCH_ACTION' => append_sid ("admin_rebuild_search.$phpEx"))
		);
		
		$template->set_filenames (array (
		    'body' => 'admin/rebuild_search_body.tpl')
		);
	}
}
// Generate the page
$template->pparse ('body');
include('./page_footer_admin.'.$phpEx);

?>