<?php
/***************************************************************************
 *					functions_expire.php
 *					-------------------
 *	begin			: June, Feb 05, 2003
 *	copyright		: (C) Przemo http://www.przemo.org
 *	email			: przemo@przemo.org
 *	version			: 1.8
 *
 ***************************************************************************/

/***************************************************************************
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 ***************************************************************************/


function get_last_forum_post($forum_id)
{
	global $db;

	$sql = "SELECT MAX(post_id) AS last_post_id
		FROM " . POSTS_TABLE . "
		WHERE forum_id = $forum_id";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not select post from posts table', '', __LINE__, __FILE__, $sql);
	}

	$last_data = $db->sql_fetchrow($result);
	if ( $last_data['last_post_id'] )
	{
		return $last_data['last_post_id'];
	}
	else
	{
		return '0';
	}
}


function delete_poll_data($topic_id)
{
	global $db;

	$sql = "SELECT vote_id FROM " . VOTE_DESC_TABLE . "
		WHERE topic_id = $topic_id";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not select poll data', '', __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$vote_id = $row['vote_id'];

	$sql = "DELETE FROM " . VOTE_DESC_TABLE . "
		WHERE topic_id = $topic_id";
	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not delete poll description', '', __LINE__, __FILE__, $sql);
	}

	$sql = "DELETE FROM " . VOTE_RESULTS_TABLE . "
		WHERE vote_id = $vote_id";
	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not delete poll results', '', __LINE__, __FILE__, $sql);
	}

	$sql = "DELETE FROM " . VOTE_USERS_TABLE . "
		WHERE vote_id = $vote_id";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not delete poll voters', '', __LINE__, __FILE__, $sql);
	}
}


function delete_post($post_id, $user_id, $forum_id)
{
	global $db, $phpbb_root_path, $phpEx, $board_config, $phpbb_root_path;

	$sql = "DELETE FROM " . POSTS_TABLE . "
		WHERE post_id = $post_id";
	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not delete post from posts table', '', __LINE__, __FILE__, $sql);
	}

	$sql = "DELETE FROM " . POSTS_TEXT_TABLE . "
		WHERE post_id = $post_id";
	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Error in deleting post text', '', __LINE__, __FILE__, $sql);
	}

	require($phpbb_root_path . 'includes/functions_search.'.$phpEx);
	if ( $board_config['search_enable'] )
	{
		remove_search_post($post_id);
	}

	if ( no_post_count($forum_id) )
	{
		$sql = "UPDATE ". USERS_TABLE ."
			SET user_posts = user_posts - 1
			WHERE user_id = $user_id";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error updating user post count', '', __LINE__, __FILE__, $sql);
		}
	}
}


function delete_topic($topic_id, $topic_vote, $topic_moved_id, $forum_id)
{
	global $db, $board_config;

	$sql = "SELECT post_id,poster_id FROM " . POSTS_TABLE . "
		WHERE topic_id = $topic_id";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not select posts from posts table', '', __LINE__, __FILE__, $sql);
	}
	$row_count = $db->sql_numrows($result);
	while($post_data = $db->sql_fetchrow($result))
	{
		delete_post($post_data['post_id'], $post_data['poster_id'], $forum_id);
	}
	$last_post_id = get_last_forum_post($forum_id);

	$sql = "UPDATE ". FORUMS_TABLE ."
		SET forum_posts = forum_posts - $row_count, forum_topics = forum_topics - 1, forum_last_post_id = $last_post_id
		WHERE forum_id = $forum_id";
	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not update forum table', '', __LINE__, __FILE__, $sql);
	}

	$sql = "DELETE FROM " . TOPICS_WATCH_TABLE . "
		WHERE topic_id = $topic_id";
	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not change topic notify data', '', __LINE__, __FILE__, $sql);
	}
	if( $topic_vote == '1' )
	{
		delete_poll_data($topic_id);
	}

	$sql = "DELETE FROM " . TOPICS_TABLE . "
		WHERE topic_id = $topic_id";
	if	( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not delete topic from topics table', '', __LINE__, __FILE__, $sql);
	}

	if ( $board_config['read_tracking'] )
	{
		$sql = "DELETE FROM " . READ_HIST_TABLE . "
			WHERE topic_id = $topic_id";
		if ( !$db->sql_query($sql) )
		{
//			message_die(GENERAL_ERROR, 'Could not delete from read_history', '', __LINE__, __FILE__, $sql);
		}
	}
	if ( $board_config['ignore_topics'] )
	{
		$sql = "DELETE FROM " . IGNORE_TOPICS_TABLE . "
			WHERE topic_id = $topic_id";
		if ( !$db->sql_query($sql, BEGIN_TRANSACTION) )
		{
//			message_die(GENERAL_ERROR, 'Could not delete topics from topics_ignore table', '', __LINE__, __FILE__, $sql);
		}
	}
}


function prune_post($post_id,$topic_id,$forum_id,$user_id)
{
	global $db;

	$sql = "SELECT topic_id, forum_id, topic_vote, topic_first_post_id, topic_last_post_id, topic_moved_id
	FROM " . TOPICS_TABLE . "
		WHERE topic_first_post_id = $post_id
			OR topic_last_post_id = $post_id";
	$result = $db->sql_query($sql);
	if ( $db->sql_numrows($result) != '0' )
	{
		while ( $topic_data = $db->sql_fetchrow($result) )
		{
			if ( (($topic_data['topic_first_post_id'] == $post_id) && ($topic_data['topic_last_post_id'] == $post_id)) || ($topic_data['topic_first_post_id'] == $post_id) )
			{
				delete_topic($topic_data['topic_id'], $topic_data['topic_vote'], $topic_data['topic_moved_id'], $topic_data['forum_id']);
			}
			else
			{
				delete_post($post_id,$user_id,$forum_id);
				if ( $topic_data['topic_last_post_id'] == $post_id )
				{
					$last_post_id = get_last_forum_post($forum_id);

					$sql = "UPDATE " . TOPICS_TABLE ."  
					SET topic_last_post_id = $last_post_id, topic_replies = topic_replies - 1 WHERE topic_id = $topic_id";
					if ( !$db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, 'Could not update topics data', '', __LINE__, __FILE__, $sql);
					}
				}
				$topic_id = $topic_data['topic_id'];

				$sql = "SELECT MAX(post_id) AS post_id FROM " . POSTS_TABLE . "
					WHERE topic_id = $topic_id";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not select latest post data', '', __LINE__, __FILE__, $sql);
				}
				$row = $db->sql_fetchrow($result);
				if ( $row['last_post_id'] )
				{
					$last_post_id = $row['post_id'];

					$sql = "UPDATE ". TOPICS_TABLE ."
						SET topic_last_post_id = $last_post_id, topic_replies = topic_replies - 1
						WHERE topic_id = $topic_id";
					if ( !$db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, 'Could not update topics data', '', __LINE__, __FILE__, $sql);
					}
				}
				$last_post_id = get_last_forum_post($forum_id);

				$sql = "UPDATE ". FORUMS_TABLE ."
					SET forum_posts = forum_posts - 1,forum_last_post_id = $last_post_id
					WHERE forum_id = $forum_id";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not update forums table', '', __LINE__, __FILE__, $sql);
				}
			return 0;
			}
		}
	}
	else
	{
		delete_post($post_id,$user_id,$forum_id);

		$sql = "UPDATE " . FORUMS_TABLE . "
			SET forum_posts = forum_posts - 1
			WHERE forum_id = $forum_id";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not update forums table', '', __LINE__, __FILE__, $sql);
		}

		$sql = "UPDATE " . TOPICS_TABLE . "
			SET topic_replies = topic_replies - 1
			WHERE topic_id = $topic_id";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not update topic data', '', __LINE__, __FILE__, $sql);
		}
	}
}

?>