<?php
/****************************************************************************** 
* 
*  File: read_history.inc 
*  Author:  Ken Brookman 
*  Created: 10/20/02 
*  Notes:  Made for phpBB 2.0.1 using mySQL v4.0 on Free BSD 
*  Desc:  This will include some of the functions necessary to add smart post 
*			tracking to phpBB. 
* 
******************************************************************************/ 

function smart_mark_all_read()
{
	global $db, $userdata;

	if ($userdata['session_logged_in'])
	{
		$sql = "REPAIR TABLE " . READ_HIST_TABLE . "";

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error in marking all as read', '', __LINE__, __FILE__, $sql);
		}
		
		$sql = "DELETE FROM " . READ_HIST_TABLE . " WHERE user_id = "
			. $userdata['user_id'];

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error in marking all as read', '', __LINE__, __FILE__, $sql);
		}
	}
}


function smart_submit(&$forum_id, &$topic_id, &$current_time, &$post_id)
{
	global $db, $userdata, $board_config;
	
	$time_to_read = ( time() - ( $board_config['lastvisit_days'] * 86400 ) );

	$sql = "SELECT forum_id, auth_read, auth_view "
		. "FROM " . FORUMS_TABLE . " WHERE "
		. "forum_id = $forum_id AND "
		. "(auth_read > 1 OR auth_view > 1)";

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Error in submit checking forum access', '',
						__LINE__, __FILE__, $sql);
	}

	if ( $row = $db->sql_fetchrow($result) )
	{
		$sql = "INSERT DELAYED IGNORE INTO " . READ_HIST_TABLE . " "
			. "(user_id, forum_id, topic_id, post_id, post_time) "
			. "SELECT DISTINCT us.user_id, $forum_id, $topic_id, $post_id, $current_time "
			. "FROM " . USER_GROUP_TABLE . " ug, " . AUTH_ACCESS_TABLE. " aa, " . USERS_TABLE . " us "
			. "WHERE aa.forum_id = $forum_id AND "
			. "us.user_lastvisit > " . $time_to_read . " AND "
			. "us.user_active = 1 AND "
			. "ug.user_pending = 0 AND "
			. "ug.user_id != " . $userdata['user_id'] . " AND "
			. "us.user_id != '-1' AND "
			. "aa.group_id = ug.group_id AND "
			. "ug.user_id = us.user_id AND ";

		if ($row['auth_view'] > 0)
		{
			if ($row['auth_read'] > 0)
			{
				$sql .= "((aa.auth_read != 0 AND aa.auth_view != 0) OR "
						  . "aa.auth_mod = 1)";
			}
			else
			{
				$sql .= "(aa.auth_view != 0 OR  aa.auth_mod = 1)";
			}
		}
		else
		{
			$sql .= "(aa.auth_read != 0 OR  aa.auth_mod = 1)";
		}

		$sql .= " OR us.user_level = 1";

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error in submit of restricted forum', '',
							__LINE__, __FILE__, $sql);
		}
	}
	else
	{
		$sql = "INSERT DELAYED INTO " . READ_HIST_TABLE . " "
				 . "(user_id, forum_id, topic_id, post_id, post_time) "
				 . "SELECT DISTINCT user_id, $forum_id, $topic_id, $post_id, $current_time "
				 . "FROM " . USERS_TABLE . " "
				 . "WHERE user_id != " . $userdata['user_id'] . " AND "
				 . "user_lastvisit > " . $time_to_read . " AND "
	 			 . "user_id != '-1' AND "
				 . "user_active = 1 ";


		if ( !$db->sql_query($sql) )
		{
			echo $sql."<br><br>";
			$err = $db->sql_error();
			echo $err['message']."<br><br>";
			echo $err['code'];
 
			message_die(GENERAL_ERROR, 'Error in submit of UNrestricted forum', '', __LINE__, __FILE__, $sql);
		}
	}
}

function smart_read_topic( &$topic_id )
{
	global $db, $userdata;

	if ($userdata['session_logged_in'])
	{
		$sql = "DELETE FROM " . READ_HIST_TABLE . " "
				 . "WHERE user_id = " . $userdata['user_id'] . " AND "
				 . "topic_id = $topic_id";

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error in submit of UNrestricted forum', '',
							__LINE__, __FILE__, $sql);
		}
	}
}

function smart_is_new_topic( &$topic_id )
{
	global $db, $userdata;

	if ($userdata['session_logged_in'])
	{
		$sql = "SELECT topic_id "
				 . "FROM " . READ_HIST_TABLE . " "
				 . "WHERE topic_id = $topic_id AND "
				 . "user_id = " . $userdata['user_id'];

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Error in submit checking forum access', '',
							__LINE__, __FILE__, $sql);
		}

		if ( $row = $db->sql_fetchrow($result) )
		{
			return true;
		}
	}

	return false;
}

function smart_is_new_topic_post( &$topic_id, &$post_id )
{
	global  $db, $userdata;

	if ($userdata['session_logged_in'])
	{
		$sql = "SELECT topic_id, post_id FROM " . READ_HIST_TABLE . "
				WHERE topic_id = " . $topic_id . "
				AND user_id = " . $userdata['user_id'] . "
				AND post_id = " . $post_id . "";

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Error in submit checking forum access', '',
							__LINE__, __FILE__, $sql);
		}

		if ( $row = $db->sql_fetchrow($result) )
		{
			if ( $row['post_id'] == $post_id )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
	}
}

function smart_is_new_forum( &$forum_id )
{
	global $board_config, $db, $userdata;

	if ($userdata['session_logged_in'])
	{
		$sql_ignore_topics = '';
		if ( $board_config['ignore_topics'] )
		{
			$ignore_topics = ignore_topics($userdata['user_id']);
			$sql_ignore_topics = ( $ignore_topics ) ? 'AND topic_id NOT IN (' . $ignore_topics . ')' : '';
		}

		$sql = "SELECT forum_id FROM " . READ_HIST_TABLE . "
			WHERE forum_id = $forum_id
			$sql_ignore_topics
			AND user_id = " . $userdata['user_id'] . "";

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Error in submit checking forum access', '',
							__LINE__, __FILE__, $sql);
		}

		if ( $row = $db->sql_fetchrow($result) )
		{
			return true;
		}
	}

	return false;
}

function smart_mark_forum_read( &$forum_id )
{
	global $db, $userdata;

	if ($userdata['session_logged_in'])
	{
		$sql = "REPAIR TABLE " . READ_HIST_TABLE . "";

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error in marking all as read', '', __LINE__, __FILE__, $sql);
		}

		$sql = "DELETE FROM " . READ_HIST_TABLE . " "
				 . "WHERE user_id = " . $userdata['user_id'] . " AND "
				 . "forum_id = $forum_id";

		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Error in marking all as read', '',
							__LINE__, __FILE__, $sql);
		}
	}
}

function smart_delete_topic( &$topic_id )
{
	global $db;

	$sql = "DELETE FROM " . READ_HIST_TABLE . " "
			 . "WHERE topic_id = $topic_id";

	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Error in submit of UNrestricted forum', '',
						__LINE__, __FILE__, $sql);
	}
}

function smart_delete_post( &$post_id )
{
	global $db;

	$sql = "DELETE FROM " . READ_HIST_TABLE . " "
			 . "WHERE post_id = $post_id";

	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Error in submit of UNrestricted forum', '',
						__LINE__, __FILE__, $sql);
	}
}

function smart_prune_read_history( &$days_to_prune )
{
	global $db;

	$current_time = time();

	$time_to_prune = $current_time - ($day_to_prune * 86400);
	 
	$sql = "DELETE FROM " . READ_HIST_TABLE . " "
			 . "WHERE post_time < $time_to_prune";

	if ( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Error in pruning read history', '',
						__LINE__, __FILE__, $sql);
	}
}

?>