CREATE TABLE phpbb_attach_quota (
  user_id mediumint(8) unsigned NOT NULL default '0',
  group_id mediumint(8) unsigned NOT NULL default '0',
  quota_type smallint(2) NOT NULL default '0',
  quota_limit_id mediumint(8) unsigned NOT NULL default '0',
  KEY quota_type (quota_type)
);

CREATE TABLE phpbb_quota_limits (
  quota_limit_id mediumint(8) unsigned NOT NULL auto_increment,
  quota_desc varchar(20) NOT NULL default '',
  quota_limit bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (quota_limit_id)
);

ALTER TABLE phpbb_pa_settings ADD directly_linked int(5) NOT NULL default '0';
ALTER TABLE phpbb_shoutbox DROP sb_username;
ALTER TABLE phpbb_posts ADD reporter_id MEDIUMINT(8) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_posts ADD INDEX (reporter_id);
ALTER TABLE phpbb_users ADD allowpm tinyint(1) DEFAULT '1';
ALTER TABLE phpbb_users ADD no_report_popup TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_users ADD refresh_report_popup TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_users ADD no_report_mail TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_users ADD user_avatar_width SMALLINT;
ALTER TABLE phpbb_users ADD user_avatar_height SMALLINT;
ALTER TABLE phpbb_anti_robotic_reg CHANGE reg_key reg_key CHAR(3) NOT NULL;
ALTER TABLE phpbb_ignore RENAME phpbb_ignores;
ALTER TABLE phpbb_vote_desc ADD vote_max INT(3) DEFAULT '1' NOT NULL;
ALTER TABLE phpbb_vote_desc ADD vote_voted INT(7) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_vote_desc ADD vote_hide TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_vote_desc ADD vote_tothide TINYINT(1) DEFAULT '0' NOT NULL;

INSERT INTO phpbb_attachments_config (config_name, config_value) VALUES ('attach_version','2.3.9');
INSERT INTO phpbb_attachments_config (config_name, config_value) VALUES ('default_upload_quota', '0');
INSERT INTO phpbb_attachments_config (config_name, config_value) VALUES ('default_pm_quota', '0');
INSERT INTO phpbb_attachments_config (config_name, config_value) VALUES ('ftp_pasv_mode','1');
INSERT INTO phpbb_attachments_config (config_name, config_value) VALUES ('use_gd2','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('last_dtable_notify','');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_no_guestes', '1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_no_auth_users', '');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_no_auth_groups', '');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_disabled_users', '');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_disabled_groups', '');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_only_admin', '0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_popup_height', '250');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_popup_width', '700');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_popup_links_target', '2');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_post_hack_version', '1.0.5');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('report_disable', '1');
INSERT INTO phpbb_quota_limits (quota_limit_id, quota_desc, quota_limit) VALUES (1, 'Low', 262144);
INSERT INTO phpbb_quota_limits (quota_limit_id, quota_desc, quota_limit) VALUES (2, 'Medium', 2097152);
INSERT INTO phpbb_quota_limits (quota_limit_id, quota_desc, quota_limit) VALUES (3, 'High', 5242880);
INSERT INTO phpbb_shoutbox_config (config_name, config_value) VALUES ('allow_users_view','1');
INSERT INTO phpbb_shoutbox_config (config_name, config_value) VALUES ('allow_users','1');
INSERT INTO phpbb_shoutbox_config (config_name, config_value) VALUES ('allow_delete_m','0');
INSERT INTO phpbb_shoutbox_config (config_name, config_value) VALUES ('allow_edit_m','0');
INSERT INTO phpbb_shoutbox_config (config_name, config_value) VALUES ('color_mod','');
INSERT INTO phpbb_shoutbox_config (config_name, config_value) VALUES ('color_admin','');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('last_visitors_time','24');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('max_sig_chars_admin','6');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('max_sig_chars_mod','3');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('viewonline','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('edit_post_date','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('restrict_smilies','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('topic_preview','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('not_anonymous_posting','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('not_anonymous_quickreply','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('max_smilies',	'24');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('portal_link',	'1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('search_enable','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('overlib',	'1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('notify_gg','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('admin_notify_gg',	'');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('admin_notify_reply','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('admin_notify_message','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('topic_start_date','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('topic_start_dateformat','d-m-y');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('all_time_ban_check','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('autorepair_tables','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('check_address','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('echange_banner','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('banners_list','<center><a href="http://phpbb.com" target="_blank"><img src="images/link_phpbb.gif" border="0"></a></center><br>[banner]<center><a href="http://forumimages.com" target="_blank"><img src="images/link_forumimages.gif" border="0"></a></center><br>[banner]<center><embed src="images/clock.swf" quality=high type="application/x-shockwave-flash" width="80" height="80"></center>');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('split_messages','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('split_messages_admin','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('split_messages_mod','1');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('split_messages_except','');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('admin_html','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('jr_admin_html','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('mod_html','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('viewtopic_warnings','0');
INSERT INTO phpbb_config (config_name, config_value) VALUES ('lastvisit_days','14');
DELETE FROM phpbb_config WHERE config_name = 'button_fl' LIMIT 1;
UPDATE phpbb_config SET config_value = '1' WHERE config_name = 'button_q';
DELETE FROM phpbb_config WHERE config_name = 'button_st' LIMIT 1;
UPDATE phpbb_config SET config_value = '1' WHERE config_name = 'button_l';
UPDATE phpbb_config SET config_value = 'Powered by <a href="http://www.phpbb.com" target="blnk" class="copyright">phpBB</a> modified v1.8 by <a href="http://www.przemo.org/phpBB2/" class="copyright" target="_blank">Przemo</a> &copy; 2003 phpBB Group' WHERE config_name = 'version';